# 23

* Enhancement: add MIB counter trigger for RMII port (switchcore.port8).
* Update: align implementation to unifiedAPI specification (version 21).
* Fix: unified-API resource `/production/oem-firmware` re-added
* Fix: optimize and reduce Buffer usage for build-in http and storage endpoints

# 22

* Fix: JSONDeserializer does not accidentally overwrite adjacent following
  properties for oversized values
* Fix: JSONDeserializer honor length of their keys, when deserializing.
* Fix: StringSerializer rounds float values when truncating to 4 decimals
* Fix: peripherals::I2C bus driver sends NACK at the end of read commands,
  according to the I²C specification.
* Fix: introduce JSONEndpoint and X509Endpoints to reflect http::Endpoints content-type.

# 21

* Update: HTTP server uses persistent connections for HTTPs clients.
* Enhancement: the MQTT client implements the unified-API (`/mqtt_client`). It
  provides now also status information.
* Update: the MQTT client allows unauthorized connectivity to an MQTT-broker.
  Event when mTLS has been enabled. The status of the connection is reflected in
  the status information via the update RESTful API.
* Update: the MQTT client supports connections to an MQTT-broker via TLS
  __only__. Unsecured MQTT broker will __not be supported__ anymore.
* Enhancement: the MQTT client will discover MQTT broker with the same
  application_name and connect. The config option mqtt_broker_name overrides this
  behaviour, where the specified FQDN of the broker is used.
* Update: libperiCORE RESTful API bumped to __12__.
* Enhancement: attach sources for Perinet's component based event driven operating system, seve.
* Fix: IPv6 Link Local address will not be checked for duplicated addresses
  anymore. This allows faster linkup time and delivery of sensor values. The IPv6LLA is determined
  with the build in MAC address, which already guaranties a unique IPv6-LLA.
* add services `Node`-,`Lifecycle`-, `Security`-, `HTTP`- and
  `MQTTClient`-Service from Perinet's [unifiedAPI
  Specification](https://gitlab.com/perinet/unified-api) repository.

# 20

* Update: reduce firmware size for applications by activating the garbage
  collection at link time.
* Update: support TLS with the elliptic curve Diffie–Hellman (ECDH) key
  agreement scheme X25519, one of the fastest curves in ECC.
* Update: add a more generic I2C bus driver implementation to the peripherals
  interface (periCORE/peripherals/I2C.h). `node_environment.peripherals.i2c.get_inport_bus()` 
* Update: enhance C++ interface to retrieve MDI port statistics, like dropped
  packets, Signal Quality Indicator (SQI).
* Update: allow applications to optimize the buffer size on peripherals/UART RX path.
  therefore the interface (periCORE/peripherals/UART.h) has been extended with `set_rx_pool(BufferPool&)` which is mandatory to set, before calling `node_environment.peripherals.uart.set_outport(...)`.
* Fix: wrong access rights behaviour was fixed, where a lower role was able to
  perform operations of higher roles, e.g. role USER was able to change
  configuration settings when it must not.
* Fix: prevent transmitting of malformed mDNS packets (PCORE-165) when no
  mqtt_broker_name has been configured.
* Update: Add property 'incarnation' to NodeInfo object.


# 19

* Fix: TarHandler: Reset TarHandler after each update to have idempotent update
  behaviour
* Fix: prevent updates from failing when using Firefox during firmware update
  (PCORE-69)
* Fix: prevent Buffer loss while doing a soft reset on GMAC hardware in case of
  a detected fail
* Fix: enable secure renegotiation (TLS) to prevent potential man-in-the-middle
  injection or Denial of Service attacks.
* Update: add PortConfig to allow advanced switch configurations, including
  RMII|RMII_10BASE.
* Update: add switchcore in NodeEnvironment to reflect physical Network interfaces
* Update: libperiCORE API version bump to 2.0
* Update: add GPIO3 GPIO4 to libperiCORE API
* Fix: libperiCORE C++ API adds constraint for JSONSerializer components now, to
  enhance semantic of potential error messages.
* Fix: JSONSerializer enhanced precision for float values
* Update: Webui is assumed to be stored gzip content-encoded
* Update: http::Endpoint has been unified
* Update: peripheral::UART add setter to change baud rate
* Fix: activate LED blink pattern according IEC 63171-6
* Fix: sève fixes a bug where an unwanted assertion is fired when the last
  buffer of the pool is freed.

# Revision 18

* Enhancement: Install the changelog

# Revision 17

* Enhancement: prevent installing internal source code files
* Fix: HttpServer: Reduce number of http connections

# Revision 16

* Fix: BCMFlashSink: Invalidate unused firmware partition
* Fix: MQTTClient: proper handling of hash mark topics

# Revision 15

* Enhancement: Add PVT monitoring

# Revision 14

* Fix: deactivate entering of forced breakpoints for release builds
* Fix: activate WatchDog trigger
* Fix: reactivate mTLS for MQTT client implementation
* Fix: workaround potential 100BASE-T1 link-up failure after power cycle
* Add MQTT-broker list access via "/mqtt" path
  * libperiCORE based nodes provide a list of discovered mqtt-brokers, acquired
    via dns-sd announcements.
* Firmware rebranding support
  * support rebranded products with dedicated firmware from any periNODE
* Fix: Let firmware reset also fall back to production firmware.

# Revision 13 and before

* add internal C++ API
  * MQTT-Endpoints
  * Event-driven I2C, UART, GPIO
* add support for custom firmware development
  * add internal API (std C++20)
  * add application development container (including toolchain)
  * add pre-compiled library for periCORE base functionality

# Revision 12 and before

* TLS1.2 for MQTT client and HTTP server
* RBAC - role based access control via mTLS
* HTTP server
* RESTful API
* mDNS resolver/responder
* LLMNR protocol implementation
* DNS-SD service announcement (_https._tcp)
* TCP/IPv6 stack
* JSON-De/Serializer
* Add peripheral interfaces, UART, I2C and GPIO
